/*
 * kwin_iaora.h
 *
 * Copyright 2008 Gustavo Pichorim Boiko <boiko@mandriva.com>
 * Skulpture Copyright 2008 Christoph Feck
 * Copyright 2008-2009 Rodrigo Gonçalves de Oliveira <rodrigo@mandriva.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#ifndef KWIN_IAORA_H
#define KWIN_IAORA_H 1


/*-----------------------------------------------------------------------*/

#include <kcommondecoration.h>
class QStyleOptionButton;

class IaOraDecorationButton : public KCommonDecorationButton
{
	Q_OBJECT

	public:
		IaOraDecorationButton(ButtonType type, KCommonDecoration *parent);
		virtual ~IaOraDecorationButton();
		virtual void reset(unsigned long changed);

	protected:
		virtual void paintEvent(QPaintEvent *event);

	protected:
		void initStyleOption(QStyleOptionButton &opt);

	private:
		void enterEvent(QEvent *e);
		void leaveEvent(QEvent *e);
		void init();
		bool m_isHover;
};


/*-----------------------------------------------------------------------*/

class QStyleOption;

class IaOraDecoration : public KCommonDecoration
{
	Q_OBJECT

	public:
		IaOraDecoration(KDecorationBridge *bridge, KDecorationFactory *factory);
		virtual ~IaOraDecoration();

	public:
		virtual QString visibleName() const;
		virtual bool decorationBehaviour(DecorationBehaviour behaviour) const;
		virtual int layoutMetric(LayoutMetric lm, bool respectWindowState = true, const KCommonDecorationButton *button = 0) const;
		virtual void updateWindowShape();

		virtual void init();
		virtual KCommonDecorationButton *createButton(ButtonType type);

		virtual void paintEvent(QPaintEvent *event);

	protected:
		void initStyleOption(QStyleOption &opt);

	private:
		/* cached style hints and pixel metrics */
		bool coloredFrame;
		bool contrastFrame;
		bool noBorder;
		bool autoRaise;
		int titleHeight;
		int borderWidth;
};


/*-----------------------------------------------------------------------*/

#include <kdecorationfactory.h>

class IaOraDecorationFactory : public KDecorationFactory
{
	public:
		IaOraDecorationFactory();
		virtual ~IaOraDecorationFactory();

	public:
		virtual KDecoration *createDecoration(KDecorationBridge *bridge);
		virtual bool reset(unsigned long changed);
		virtual QList<BorderSize> borderSizes() const;
		virtual bool supports(Ability ability) const;
};


/*-----------------------------------------------------------------------*/

#endif


